#
# spec file for package ZoneMinder
#
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to monex@liquid-co.de
#

# norootforbuild

%bcond_with mp_package
%bcond_without debug 

%if %{with mp_package}
Name:           ZoneMinder-MP
%else
Name:           ZoneMinder
%endif
BuildRequires:  update-desktop-files apache2 pcre-devel libjpeg-devel gcc gcc-c++ perl perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools perl-Sys-Mmap vorbis-tools unzip libmysqlclient-devel libgcrypt-devel libgnutls-devel perl-macros fdupes cmake libcurl-devel polkit-devel systemd ffmpeg-4-libavcodec-devel ffmpeg-4-libswscale-devel ffmpeg-4-libswresample-devel ffmpeg-4-libpostproc-devel ffmpeg-4-libavutil-devel ffmpeg-4-libavresample-devel ffmpeg-4-libavformat-devel ffmpeg-4-libavfilter-devel ffmpeg-4-libavdevice-devel vlc-devel

BuildRequires:  php7 apache2-mod_php7 php7-mysql php7-bz2 php7-gd php7-zlib php7-iconv php7-sockets

%if %{with mp_package}
BuildRequires:  faac libfaad-devel lame libxvidcore-devel libx264-devel
%endif

%{perl_requires}
%{?systemd_requires}
Requires:       apache2 php7 php7-mbstring apache2-mod_php7 php7-mysql php7-bz2 php7-gd php7-zlib php7-iconv php7-sockets php7-zip php7-APCu netpbm  mysql perl-Archive-Tar perl-Archive-Zip perl-DBI perl-DBD-mysql perl-Crypt-SSLeay perl-XML-Parser perl-libwww-perl perl-Date-Manip perl-MIME-Lite perl-MIME-tools perl-Sys-Mmap zip perl-PHP-Serialization perl-Sys-MemInfo perl-Sys-CPU perl-Data-UUID perl-Class-Std-Fast perl-SOAP-WSDL perl-Number-Bytes-Human perl-IO-Socket-Multicast perl-Cpanel-JSON-XS perl-JSON-MaybeXS
Requires:       python3-zm_database_init >= 3.2.1
Requires(post): permissions
Requires(pre):  shadow
%if %{with mp_package}
Requires:       ffmpeg lame
%endif

Recommends:     perl-Device-SerialPort perl-Net-SFTP-Foreign perl-Expect php7-gd

%if %{with mp_package}
Conflicts:      ZoneMinder
%endif

License:        GPL
Group:          Productivity/Networking/Web/Servers
Summary:        A Linux based camera monitoring and analysis tool
Version:        1.32.3
Release:        8.1
Packager:       Monex <monex@liquid-co.de>
URL:            http://www.zoneminder.com/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source0:        zoneminder-%{version}.tar.gz
Source1:        zm.service
Source2:        zm.logrotate
Source3:        README.SuSE
Source4:        zm.apache
Source5:        permissions
Source6:        permissions.secure
Source7:        permissions.paranoid
Source8:        MooTools-Core-1.6.0-compat.js
Source9:        LICENSE.mootools
Source10:       zm_tempfiles.conf
Source11:       zoneminder_mysql_settings.cnf
Source12:       crud-3.1.0-zm.tar.gz
Source13:       zm.42.3.service
Source14:       CakePHP-Enum-Behavior-1.0-zm.tar.gz
Patch1:         zm.conf.patch
Patch2:         zm_database_default_config.patch
Patch3:         ignore_signal_on_config_write.patch
Patch4:         reload_config.patch
Patch5:         fix-ZM_VERSION-already-defined-error.patch
Patch6:         systemd-name-conventions.patch
Patch7:         move-include-sys-uio.h-outside-defined-BSD-block.patch

%description
ZoneMinder is an integrated set of applications which provide a complete surveillance solution allowing capture, 
analysis, recording and monitoring of any CCTV or security cameras attached to a Linux based machine. 
It is designed to run on distributions which support the Video For Linux (V4L) interface and has been tested 
with video cameras attached to BTTV cards, various USB cameras and also supports most IP network cameras.


%debug_package
%prep

%if %{with mp_package}
%setup -q -n zoneminder-%{version}
%else
%setup -q -n zoneminder-%{version}
%endif
cp -a %SOURCE3 .
cp -a %SOURCE9 .
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

# add ZM_VERSION to config file
cat >> zm.conf.in << EOF

# Current version of ZoneMinder
ZM_VERSION=%{version}

EOF

#install Crud
pushd web/api/app/Plugin/Crud/
tar xfvz %SOURCE12 --strip 1
popd

#install enum behaviour
pushd web/api/app/Plugin/CakePHP-Enum-Behavior
tar xfvz %SOURCE14 --strip 1
popd


%build
export CFLAGS=$RPM_OPT_FLAGS
export CXXFLAGS=$RPM_OPT_FLAGS

cmake \
  -DZM_DB_HOST=localhost \
  -DZM_DB_NAME=zm \
  -DZM_DB_USER=zm_admin \
  -DZM_RUNDIR=/var/run/zm \
  -DZM_TMPDIR=/tmp \
  -DZM_LOGDIR=/var/log/zm \
  -DZM_MYSQL_ENGINE=InnoDB \
  -DZM_WEBDIR=/usr/share/zoneminder/www \
  -DZM_CGIDIR=/usr/lib/zoneminder/cgi-bin \
  -DZM_LOGDIR=/var/log/zm \
  -DZM_RUNDIR=/var/run/zm \
  -DZM_SOCKDIR=/var/run/zm \
  -DZM_NO_FFMPEG=OFF \
  -DENABLE_MMAP=yes \
  -DZM_WEB_USER=wwwrun \
  -DZM_WEB_GROUP=www \
  -DCMAKE_INSTALL_PREFIX=/usr

%{__make} %{?_smp_mflags} VERBOSE=1

%install
make DESTDIR=$RPM_BUILD_ROOT install

# rm -f %buildroot/srv/www/htdocs/zm/api/.editorconfig
# rm -f %buildroot/srv/www/htdocs/zm/api/.gitattributes
# rm -f %buildroot/srv/www/htdocs/zm/api/.gitignore

%perl_process_packlist
%perl_gen_filelist
%__install -m 700 -d %buildroot/usr/share/zoneminder/db
%__install -m 600 db/*.sql %buildroot/usr/share/zoneminder/db

for f in %{_sysconfdir}/logrotate.d %{_sysconfdir}/init.d /usr/sbin %{_sysconfdir}/cron.hourly/ /var/log %{_sysconfdir}/apache2/vhost.d %{_sysconfdir}/permissions.d/ /var/run/zm /var/cache/zoneminder /var/lib/zoneminder/events /var/lib/zoneminder/images
do
    %__install -d %buildroot/$f
done

for f in %{_unitdir} /usr/lib/tmpfiles.d
do
  %__install -d %buildroot/$f
done

%if 0%{?sle_version} == 120300 && 0%{?is_opensuse}
%__install -m 644 %{S:13} %{buildroot}/%{_unitdir}/zm.service
%else
%__install -m 644 %{S:1} %{buildroot}/%{_unitdir}
%endif
%__install -m 644 %{S:10} %{buildroot}/usr/lib/tmpfiles.d
%__install -d -m 750 %{buildroot}/%{_sysconfdir}/my.cnf.d/
%__install -m 640 %{S:11} %{buildroot}/%{_sysconfdir}/my.cnf.d/zoneminder_mysql_settings.cnf

%__install -m 775 -d %buildroot/var/log/zm
%__install -m 644 %{S:2} %buildroot/%{_sysconfdir}/logrotate.d/zm
%__install -m 644 %{S:4} %buildroot/%{_sysconfdir}/apache2/vhost.d/zm.conf

%__install -m 644 %{S:5} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:5} %{buildroot}%{_sysconfdir}/permissions.d/%{name}.easy

%__install -m 644 %{S:6} %{buildroot}%{_sysconfdir}/permissions.d/%{name}
%__install -m 644 %{S:7} %{buildroot}%{_sysconfdir}/permissions.d/%{name}

%__install -m 644 %{S:8} %buildroot/usr/share/zoneminder/www/mootools.js

echo %version > %buildroot/usr/share/zoneminder/version


%fdupes -s $RPM_BUILD_ROOT/%_mandir
%fdupes $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.files
%defattr(-,root,root)
%dir /usr/share/zoneminder
%dir /usr/share/zoneminder/db
/usr/share/zoneminder/version
/usr/share/zoneminder/icons/*
/usr/share/zoneminder/db/*.sql
/usr/share/polkit-1/actions/com.zoneminder.systemctl.policy
/usr/share/polkit-1/rules.d/com.zoneminder.systemctl.rules
%{_sysconfdir}/apache2/vhost.d/*.conf
%dir /usr/share/zoneminder/www/
/usr/share/zoneminder/www/*
/usr/lib/zoneminder/cgi-bin/*
/usr/share/applications/zoneminder.desktop

%{_unitdir}/*
/usr/lib/tmpfiles.d/*

%defattr(-,wwwrun,www)
%dir /var/cache/zoneminder
%dir /var/lib/zoneminder/events
%dir /var/lib/zoneminder/images
%ghost /var/run/zm

%defattr(-,root,mysql)
%dir %{_sysconfdir}/my.cnf.d/
%config(noreplace) %{_sysconfdir}/my.cnf.d/zoneminder_mysql_settings.cnf

%defattr(-,root,root)
%_sysconfdir/permissions.d/*
%{_sysconfdir}/logrotate.d/zm
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README* LICENSE*
%defattr(640,root,www)
%config(noreplace) %{_sysconfdir}/zm.conf
%config(noreplace) %{_sysconfdir}/conf.d/*
%defattr(-,root,www)
%dir /var/log/zm

%post
/sbin/ldconfig
touch /usr/share/zoneminder/lock
if [ -x /usr/sbin/a2enmod ]; then
  a2enmod -q php7 || a2enmod php7
  a2enmod -q rewrite || a2enmod rewrite
fi

%service_add_post zm.service
systemd-tmpfiles --create


%pre
/usr/bin/gpasswd -a wwwrun video >/dev/null 2>&1 || :
%service_add_pre zm.service

%preun
%stop_on_removal zm
if [ $1 -eq 0 ]; then
    if test -f /usr/share/zoneminder/lock ; then
        rm -f /usr/share/zoneminder/lock
    fi
fi

%service_del_preun zm.service

%postun
%insserv_cleanup
/sbin/ldconfig

%service_del_postun zm.service

%if %{with mp_package}
%else
%endif
%changelog
* Sat Mar  9 2019 Dirk Hartmann <monex@liquid-co.de>
- Change install directory of apache vhost file.
* Sun Feb 17 2019 Dirk Hartmann <monex@liquid-co.de>
- Added missing CakePHP-Enum-Behavior.
* Tue Feb 12 2019 Dirk Hartmann <monex@liquid-co.de>
- Fix paths in config patch.
- Set user and group explicit.
* Sat Feb  9 2019 Dirk Hartmann <monex@liquid-co.de>
- Added special unit file for 42.3.
* Sat Feb  9 2019 Dirk Hartmann <monex@liquid-co.de>
- Added requirement for perl-JSON-MaybeXS.
* Sat Feb  2 2019 Dirk Hartmann <monex@liquid-co.de>
- Update to version 1.32.3.
  See https://github.com/ZoneMinder/zoneminder/releases/tag/1.32.3
  for full changelog.
* Tue Oct  9 2018 Dirk Hartmann <monex@liquid-co.de>
- Fix broken patch for not defining config values twice.
* Wed Oct  3 2018 Dirk Hartmann <monex@liquid-co.de>
- Update to version 1.32.1.
  See https://github.com/ZoneMinder/zoneminder/releases/tag/1.32.1
  for full changelog.
* Fri Jun 29 2018 monex@liquid-co.de
- Require new zm_database_init version
* Wed Jun 13 2018 monex@liquid-co.de
- Fix zm.service file.
  ZM failed to start with the following error message:
  New main PID XXX does not belong to service, and PID file is not owned by root. Refusing.
  Added User= and Group= as a fix for this issue
* Thu May 31 2018 monex@liquid-co.de
- Update to ZoneMinder 1.30.4
- Change to php7
* Sun Dec 10 2017 monex@liquid-co.de
- Added some missing directories for zmNinja
* Fri Nov 24 2017 monex@liquid-co.de
- Applay missing patch for ZM_VERSION already defined error.
* Fri Nov 24 2017 monex@liquid-co.de
- Fix missing ZM_VERSION
* Sun Nov 12 2017 monex@liquid-co.de
- Revert last change.
* Sun Nov 12 2017 monex@liquid-co.de
- Removed lame requirements.
* Tue Aug 22 2017 monex@liquid-co.de
- Remove obsolete section.
* Tue Aug 22 2017 monex@liquid-co.de
- Fix security permission problem for events and images.
* Tue Aug 15 2017 monex@liquid-co.de
- Removed obsolete Requires.
* Tue Aug 15 2017 monex@liquid-co.de
- Added missing sources.
* Mon May  1 2017 monex@liquid-co.de
- Updated to version 1.30.2
  See https://github.com/ZoneMinder/ZoneMinder/releases/tag/1.30.2
  for a full description of changes.
- Cleanup of spec file for older discontinued versions.
* Sun Dec 25 2016 monex@liquid-co.de
- Changes for 42.2 packages.
* Wed Aug 24 2016 monex@liquid-co.de
- Eevert last change because it breaks custom states
* Sun Aug 21 2016 monex@liquid-co.de
- Fix web control start/stop/restart
* Thu Aug 18 2016 monex@liquid-co.de
- Fix montage view
* Mon Aug 15 2016 monex@liquid-co.de
- Fix dependencies to ffmpeg
* Sun Aug 14 2016 monex@liquid-co.de
- updated MP requirements for 42.1
* Sat Aug 13 2016 monex@liquid-co.de
- Added perl module dependencies for ONVIF.
* Sun Aug  7 2016 monex@liquid-co.de
- Fix wrong patch due to last change
* Sun Aug  7 2016 monex@liquid-co.de
- Fix order of update execution on startup/shutdown.
* Sun Aug  7 2016 monex@liquid-co.de
- Modified BuildRequired for MP Build
* Sun Aug  7 2016 monex@liquid-co.de
- Fix MP build
- Updated cambozola to latest version.
- Updated mootools to latest version.
* Sat Aug  6 2016 monex@liquid-co.de
- Update to version 1.30.0
  * see https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.30.0 for changes.
* Sat Mar 12 2016 monex@liquid-co.de
- Updated to version 1.29.0
  * see https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.29.0 for changes
* Mon Feb 15 2016 monex@liquid-co.de
- Load enable php5 apache module if not already enabled.
* Fri Dec 25 2015 monex@liquid-co.de
- fix patch.
* Fri Dec 25 2015 monex@liquid-co.de
- Chages for new ffmpeg api.
* Fri Dec 11 2015 monex@liquid-co.de
- change requirement for libffmpeg
* Sun Feb 15 2015 monex@liquid-co.de
- update to version 1.28.1
  for full changelog look at https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.28.1
* Tue Nov  4 2014 monex@liquid-co.de
- update to version 1.28.0
  for full changelog look at https://github.com/ZoneMinder/ZoneMinder/releases/tag/v1.28.0
* Tue Sep 23 2014 monex@liquid-co.de
- force rebuild
* Sun May 25 2014 monex@liquid-co.de
- ignore return value of usermod
* Sun May 25 2014 monex@liquid-co.de
- fix groupadd for suse < 12.3
* Sun May 25 2014 monex@liquid-co.de
- allow to set date format depending on language settings
- add wwrun to group video during installation to avoid
  permission problems
* Sun May 18 2014 monex@liquid-co.de
- added patch to avoid ZM_VERSION already defined php error
* Sun May  4 2014 monex@liquid-co.de
- fix db escapes see http://www.zoneminder.com/forums/viewtopic.php?f=31&t=22196
* Sun May  4 2014 monex@liquid-co.de
- use mb_strtolower when accessing translation files because of
  utf-8 encoding. See http://www.zoneminder.com/forums/viewtopic.php?f=31&t=22195
* Wed Apr 30 2014 monex@liquid-co.de
- added patch which fixes user defined language selection
* Mon Apr 28 2014 monex@liquid-co.de
- added patch to get xml view working again
* Tue Apr 22 2014 monex@liquid-co.de
- use build root when creating mysql config directory
* Tue Apr 22 2014 monex@liquid-co.de
- fix of directory install (used wrong syntax)
* Tue Apr 22 2014 monex@liquid-co.de
- set config no replace option for zm mysql configuration file
* Fri Apr 18 2014 monex@liquid-co.de
- added specialised mysql configuration file for zoneminder
  places in my.cnf.d to disable default sql_mode
* Thu Apr  3 2014 monex@liquid-co.de
- added reload config patch
* Thu Apr  3 2014 monex@liquid-co.de
- add version to config file so that zm_database_init works again
* Wed Apr  2 2014 monex@liquid-co.de
- update to version 1.27.0
  * A new skin!
  * zmcamtool.pl
  * Docker
  * A new camera source type, libvlc.
  * Better RTSP support! This fixed a regression in #221
  * Fixed that annoying bug where you could create zones larger
    than the image they belong to [b368d30]
  * Better WansView camera detection support
* Sun Jan  5 2014 monex@liquid-co.de
- fix ZM_NO_FFMPGEG option
- added patches:
  * fix_ZM_NO_FFMPGEG.patch
- modified patches:
  * fix_perl_install.patch
  * systemd_zm_control.patch
  * zm.conf.patch
  * zm_database_default_config.patch
  * zmpkg_db_init.patch
* Fri Jan  3 2014 monex@liquid-co.de
- update to version 1.26.5
  * Better RTSP support! This fixed a regression in #221
  * Fixed that annoying bug where you could create zones larger
    than the image they belong to [b368d30]
  * Better WansView camera detection support
* Fri Dec  6 2013 monex@liquid-co.de
- add missing dependency
* Fri Dec  6 2013 monex@liquid-co.de
- switch to MMAP and enable it explicit
  (see http://www.zoneminder.com/forums/viewtopic.php?p=82434#p82434)
* Sat Nov 16 2013 monex@liquid-co.de
- don't apply systemd patch for 11.4 builds
* Wed Nov 13 2013 monex@liquid-co.de
- don't call zmupdate.pl during zmpkg.pl
  this is a task of zm_database_init
* Tue Nov 12 2013 monex@liquid-co.de
-  set also ZM_PATH_BUILD to /usr/share/zm with patch
* Tue Nov 12 2013 monex@liquid-co.de
- disable mmap again
* Mon Nov 11 2013 monex@liquid-co.de
- update to ZoneMinder version 1.26.4
* Sun Aug 11 2013 monex@liquid-co.de
- disable mmap because zmtrigger.pl is not working with
  mmap. See
  http://www.zoneminder.com/forums/viewtopic.php?f=29&t=19318&p=76020#p76020
* Sat Aug 10 2013 monex@liquid-co.de
- fix ffmpeg deprecated functions
* Mon Apr 29 2013 monex@liquid-co.de
- added patch from https://bugzilla.redhat.com/show_bug.cgi?id=903063
* Sat Apr 20 2013 monex@liquid-co.de
- delete/insert config within transaction to prevent
  invalid configuration reads by other processes.
- use systemd to start/stop/restart ZoneMinder via webfrontent.
  Using zmpkg.pl from webfrontend confused systemd which then
  showed a wrong state.
  This behaviour is optional so new configuration option under
  in system category was introduced.
* Thu Apr 11 2013 monex@liquid-co.de
- updated systemd unit file to use ZoneMinder PIDFile
  Type is forking now instead of simple
* Fri Mar 29 2013 monex@liquid-co.de
- compile zoneminder with mmap enables
* Tue Mar 12 2013 monex@liquid-co.de
- applied patch for shared memory debug purpose
* Tue Mar 12 2013 monex@liquid-co.de
- use cast instead
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
  found another one
* Tue Mar 12 2013 monex@liquid-co.de
- fix compile for 12.3 by using v4l enum type
* Tue Mar 12 2013 monex@liquid-co.de
- added unified uptime patch to fix uptime output
  in webfrontend
* Sat Mar  9 2013 monex@liquid-co.de
- changed dependency from x264-devel to libx264-devel
* Tue Oct 16 2012 monex@liquid-co.de
- rebuild package due to changed ffmpeg libs
* Tue Sep 11 2012 monex@liquid-co.de
- fix file list
* Tue Sep 11 2012 monex@liquid-co.de
- added use of RPM_OPT_FLAGS
* Tue Sep 11 2012 monex@liquid-co.de
- added fix compile patch for gcc-4.7
* Sun Sep  9 2012 monex@liquid-co.de
- removed unneded BuildRequires
* Sat Aug 11 2012 monex@liquid-co.de
- remove last patch as it is a php configuration issue
* Wed Aug  8 2012 monex@liquid-co.de
- first try to fix hash auth, looking out for a better solution soon
* Sat Jul 28 2012 monex@liquid-co.de
- fix compile with newer ffmpeg versions
* Wed Mar 21 2012 monex@liquid-co.de
- added startup message again
* Wed Mar 21 2012 monex@liquid-co.de
- fixed name in requires: perl-PHP-Serialization
* Tue Mar 20 2012 monex@liquid-co.de
- removed obsolete entries in init file
* Tue Mar 20 2012 monex@liquid-co.de
- added perl-php-serialization to requires so that triggers are working
* Sun Jan  1 2012 monex@liquid-co.de
- corrected last patch
* Sun Jan  1 2012 monex@liquid-co.de
- ignore signals in ConfigAdmin module to prevent Config table corruption
* Sat Dec 31 2011 monex@liquid-co.de
- fix unit file
- don't restart on update beause on systemd it will be double executed which will break
  the configuration table in database
* Fri Dec 30 2011 monex@liquid-co.de
- added restart section to unit file
* Fri Dec 30 2011 monex@liquid-co.de
- disable restart on update as it will break the Config table ind database (why?)
* Fri Dec 30 2011 monex@liquid-co.de
- added automake to build requires
* Fri Dec 30 2011 monex@liquid-co.de
- clean up old changes section
* Fri Dec 30 2011 monex@liquid-co.de
- added missing file
- fix in changelog file
